//------------------------------------------------------------------------------
// Project Rabbit II Open Source FreeWare
// http://wtwsoft.narod.ru/build.htm
// original download from http://wtwsoft.narod.ru
// mailto: wtwsoft@narod.ru
//------------------------------------------------------------------------------
//RC10
//Dictionary write by Denis Kirin
//module version 1.2 (up to build32)

unit Dictionary;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,  Dialogs,
  StdCtrls, ComCtrls, Grids, ExtCtrls, Masks, jpeg, CheckLst, Config;

const
 DictionaryFile: string = '';


type
  DIndexAtom = record
     _From, _To: integer;
  end;

  DictionBaseRecord = record
   Name,
   FileName,
   Enabled  : TStringList;
  end;

//RC11
  TDiction = record //  
    Text
    , //     
    Rules : TStringList;  //     ,    
   end;

//        
  TDictionaryForm = class(TForm)
    Panel1: TPanel;
    StringGrid1: TStringGrid;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button3: TButton;
    Label2: TLabel;
    Edit3: TEdit;
    Button5: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Button6: TButton;
    Button2: TButton;
    Button4: TButton;
    Button7: TButton;
    Bevel1: TBevel;
    procedure FormActivate(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
    procedure CheckListBox1ClickCheck(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure Edit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure StringGrid1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure StringGrid1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure AdjustCaptions;
  private
  public
  end;

//   
  function LoadDiction: boolean;//  
  function CompareMask( Text: string; RulesCount: dword; var ResultText: string ):boolean;//        
  function FiltrText( Text : string ): string;//     Text   ,      

var
  DictionaryForm: TDictionaryForm;//  
  Diction : TDiction;//  
  WordPosition : integer;
  DictionBase : DictionBaseRecord;

  DIndex: array [0..255] of DIndexAtom;
  SelCount: integer;

implementation
{$R *.dfm}
uses
 Main;
//     DictionaryFileName    Diction
function LoadDiction: boolean;
var
 FileName : string;
 DText: TStringList; //           ()
 RulesCount, j: integer; //     
 CutText, CutRules: string;
 Flag: boolean;
begin
 try

 if Diction.Text = nil then Diction.Text := TStringList.Create; //   Text   Diction    
 if Diction.Rules = nil then Diction.Rules := TStringList.Create; //     Rules
 Diction.Text.Clear; //   
 Diction.Rules.Clear;//   
 Diction.Text.Add( '' );
 Diction.Rules.Add( '' );


 DText := TStringList.Create;//     

 DictionaryFile := GetMConf('Dictionary');

 if not(FileExists(DictionaryFile)) then Exit;

// FileName := '1.dic';

 DText.Clear;
 DText.LoadFromFile( DictionaryFile ); //  ,               
 DText.Sort;

 for RulesCount := 0 to 255 do
  begin
   DIndex[RulesCount]._From := 0;
   DIndex[RulesCount]._To := 0;   
  end;

//   DText   ,   ,  
//             Diction

 for RulesCount := 0 to DText.Count-1 do //         
  begin
                                         //         ,         begin
   if DText[RulesCount] <> '' then //    
    begin
     flag := true; //     "="       

     if ( DText[RulesCount][1] <> '\' ) //          (    )
        and
        ( DText[RulesCount][1] <> '/' )
        and
        ( DText[RulesCount][1] <> ';' ) then
       begin
        for j:=1 to length( DText[RulesCount] ) do //      "="
         if DText[RulesCount][j]= '=' then flag := false; //   "="    

         if not(flag) then //   ,       "="
          begin
           flag := true; //  
           CutText := ''; //         "=",     
           CutRules := ''; //      ,    ,  

           for j:=1 to length(DText[RulesCount]) do //    ,     
            begin
             if ( DText[RulesCount][j]<>'=' ) //       
                and//   
                ( flag ) then CutText := CutText + DText[RulesCount][j] //       ,       
                  else// 
                    begin
                     flag := false;//  ,  
                     if ( DText[RulesCount][j]<>'=' )//        (     )        
                        and //   
                        ( not(flag) ) then CutRules := CutRules + DText[RulesCount][j];//     ,      
            end;
          end;

          if CutText <> '' then
          begin
           if DIndex[Ord(CutText[1])]._From = 0 then DIndex[Ord(CutText[1])]._From := Diction.Text.Count-1;
           if DIndex[Ord(CutText[1])]._To < Diction.Text.Count then DIndex[Ord(CutText[1])]._To := Diction.Text.Count-1;
           Diction.Text.Add( CutText ); //     (     ) 
           Diction.Rules.Add( CutRules ); //          
          end;
       end;
    end; //      
  end;
  end;

   DText.Destroy;
   LoadDiction := True; //    ,   
 except
   LoadDiction := false;
 end;
end;

//     Text   RulesCount,      
//    ResultText.      "*", "?"
function CompareMask( Text: string; RulesCount: dword; var ResultText: string ):boolean;
var
 NWCount : integer; //      
begin
 result := false; //   - ,   
//RC12

 if MatchesMask( AnsiUpperCase( Text ),AnsiUpperCase(Diction.Text[RulesCount])) then //       
   begin //    
    result := true; //   

//     ,       "*",      
//        ""  Text,        ("*")
   if Diction.Text[RulesCount][length(Diction.Text[RulesCount])]='*' then //  "*"    
     begin //         "*"    ,      
      ResultText := Diction.Rules[RulesCount]; //       
      for NWCount := length(Diction.Text[RulesCount])-1 to length(Text) do
       ResultText := ResultText + Text[NWCount]; //     
     end
    else
     begin
      if Diction.Text[RulesCount][1]='*' then //      
       begin
        ResultText := ''; //  
        for NWCount := 1 to length(Text)-length(Diction.Text[RulesCount])+1 do //           
         ResultText := ResultText + Text[NWCount];
        ResultText := ResultText + Diction.Rules[RulesCount]; //    
       end
      else
        ResultText := Diction.Rules[RulesCount]; //                
    end;
   end;
end;

function IsNotTerminalChar( c: char ):boolean;
begin
 case c of
  ' ', '.', ',', '!', '?', #$0D, #$0A: Result := false;
 else
  Result := true;
 end;
end;
//   Text,   (   ) 
function FiltrText( Text : string ): string;
var
 TextCount, DWordCount, RulesCount : integer;
 MirrorText, NextWord, NextDoubleWord, s4, s5 : string;
 L: integer;
 TerminalChar2, TerminalChar: Char;
begin
 try
 WordPosition := 0;
 if Text = '' then Exit; //   ,  , ,  

 MirrorText := Text; //     
 TextCount  := 0; //      
 s5  := '';  //    ,  

 l := length(MirrorText);
 repeat //  ,     ,  
  Application.ProcessMessages;
  NextWord := ''; //       


  repeat //   

   inc( TextCount ); //    
   if TextCount <= l then //      
    begin
     if IsNotTerminalChar(MirrorText[TextCount])  then NextWord := NextWord + MirrorText[TextCount] //            
    end
   else TextCount := length(MirrorText); //  ? :)    ""   ,
                                            //                          ,     
                                            //                     MirrorText[TextCount]    ()    
  until (not(IsNotTerminalChar(MirrorText[TextCount])))  //    
       or
        ( TextCount = length(MirrorText)); //    

  TerminalChar := MirrorText[TextCount];

  NextDoubleWord := NextWord + ' '; //               ,               ,   
  DWordCount := TextCount;  //    () ,            () 

  repeat //   ,    ,      
   Application.ProcessMessages;
   inc( DWordCount );
   if DWordCount <= length(MirrorText) then
    begin
     if IsNotTerminalChar(MirrorText[DWordCount]) then NextDoubleWord := NextDoubleWord + MirrorText[DWordCount]
    end
   else DWordCount := length(MirrorText);
  until (not(IsNotTerminalChar(MirrorText[DWordCount])))
       or
        ( DWordCount = length(MirrorText));

  TerminalChar2 := MirrorText[DWordCount];

 if NextWord <> '' then
 begin
 s4 := ''; //                
 WordPosition := WordPosition + length(NextWord);
 for RulesCount := DIndex[Ord(NextWord[1])]._From to DIndex[Ord(NextWord[1])]._To do //     
  begin
   if length(Diction.Text[RulesCount]) > 1 then        //        
     if length( NextWord ) > 1 then                    //         
      begin
       if ( Diction.Text[RulesCount][2] = NextWord[1]) //  ,             
         or
          ( Diction.Text[RulesCount][2] = NextWord[2]) then  //    ,                 
         begin
          if not( CompareMask( NextWord, RulesCount, s4 )) then //       
           begin
            if CompareMask( NextDoubleWord, RulesCount, s4 ) then  //    ,   
             begin
              TextCount := DWordCount;                           //    ,         
              TerminalChar :=  TerminalChar2;
              break;                                             //           s4
             end;
            end
           else break;
         end;
       end;
   end;


 if s4 = '' then // if not find then masks search
 begin
 for RulesCount := DIndex[Ord('*')]._From to DIndex[Ord('*')]._To do //     
  begin
   if length(Diction.Text[RulesCount]) > 1 then        //        
     if length( NextWord ) > 1 then                    //         
      begin
       if ( Diction.Text[RulesCount][2] = NextWord[1]) //  ,             
         or
          ( Diction.Text[RulesCount][2] = NextWord[2]) then  //    ,                 
         begin
          if not( CompareMask( NextWord, RulesCount, s4 )) then //       
           begin
            if CompareMask( NextDoubleWord, RulesCount, s4 ) then  //    ,   
             begin
              TextCount := DWordCount;                           //    ,         
              TerminalChar :=  TerminalChar2;
              break;                                             //           s4
             end;
            end
           else break;
         end;
       end;
   end;
 end;
 //  e              

  if s4 = '' then s5 := s5 + NextWord + TerminalChar
             else s5 := s5  + s4 + TerminalChar; //       

 end;

 until TextCount >= length(MirrorText); //       

 FiltrText := s5; //  ,  s5
 except
 FiltrText := Text;
 end;
end;

procedure TDictionaryForm.FormActivate(Sender: TObject);
var
 i : integer;
begin
 try
 AdjustCaptions;

 LoadDiction;

 Button3.Enabled := false;
 Edit3.Text := DictionaryFile;


// Label1.Caption := 'Diction size:' + inttostr( Diction.Text.Count-1 );


 StringGrid1.RowCount := Diction.Text.Count+1;
 StringGrid1.Cols[0].Clear;
 StringGrid1.Cols[1].Clear;

 StringGrid1.Cells[0,0] := GetLConf('DCText');
 StringGrid1.Cells[1,0] := GetLConf('DCReadAs');

 for i:=1 to Diction.Text.Count-1 do
  begin
   StringGrid1.Cells[0,i] := Diction.text[i];
   StringGrid1.Cells[1,i] := Diction.Rules[i];
  end;

 if StringGrid1.Cols[0].Count <= 1 then
  begin
   StringGrid1.Cells[0,2] := '';
   StringGrid1.Cells[1,2] := '';
  end;
  except
  end;

 Edit1Change(Sender);  
end;

procedure TDictionaryForm.StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
begin


 SelCount   := ARow;
end;

procedure TDictionaryForm.CheckListBox1ClickCheck(Sender: TObject);
begin


end;

//   ,    .     
//          StringGrid
procedure TDictionaryForm.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
var
 s : string;
 i : integer;
begin
  StringGrid1.Canvas.Font.Color := clBlack; //   
  StringGrid1.Canvas.Font.Style := [fsUnderline,fsBold]; //  -  
  StringGrid1.Canvas.Brush.Color := $00EEEbE2; //  ...
  StringGrid1.Canvas.FillRect(Rect); //    
  StringGrid1.Canvas.TextOut(Rect.Left+10, Rect.Top+1, StringGrid1.Cells[ACol,Arow] ); //    
  StringGrid1.Canvas.FillRect(Rect); //  
  s := ''; //       ,                      "..."
   if StringGrid1.Cells[ACol,Arow] <> '' then //     (     )
    begin
     for i:=1 to length(StringGrid1.Cells[ACol,Arow]) do //               
      if StringGrid1.Canvas.TextWidth( s + '...    ' ) < StringGrid1.ColWidths[ACol] then
       s := s + StringGrid1.Cells[ACol,Arow][i]; //  
      s := s + '...'; //   
    end;
end;


procedure TDictionaryForm.Button1Click(Sender: TObject);
begin
 if StringGrid1.Cols[0].IndexOf( Edit1.Text ) > -1 then
  begin
   StringGrid1.Cols[0][StringGrid1.Cols[0].IndexOf( Edit1.Text )] := Edit1.Text;
   StringGrid1.Cols[1][StringGrid1.Cols[0].IndexOf( Edit1.Text )] := Edit2.Text;   
  end
 else
  begin
   StringGrid1.RowCount := StringGrid1.RowCount + 1;
   StringGrid1.Cols[0].Add( Edit1.Text );
   StringGrid1.Cols[1].Add( Edit2.Text );
  end;
 Button3.Enabled := true;  
end;

procedure TDictionaryForm.Button4Click(Sender: TObject);
var
 s: TStringList;
 e: string;
 i: integer;
begin
 // one way to delete item from stringgrid what I found
 try
 s := TStringList.Create;
 for i:=0 to StringGrid1.Cols[0].Count-1 do s.Add( StringGrid1.Cols[0][i]);
 s.Delete(SelCount);
 StringGrid1.Cols[0].Clear;
 for i:=0 to S.Count-1 do  StringGrid1.Cols[0].Add(s[i]);

 s.Clear;

 for i:=0 to StringGrid1.Cols[1].Count-1 do s.Add( StringGrid1.Cols[1][i]);
 s.Delete(SelCount);
 StringGrid1.Cols[1].Clear;
 for i:=0 to S.Count-1 do  StringGrid1.Cols[1].Add(s[i]);

 s.Destroy;
 except
 end;
 Button3.Enabled := true;
end;

procedure TDictionaryForm.Button2Click(Sender: TObject);
begin
 Close;
end;

procedure TDictionaryForm.Button3Click(Sender: TObject);
var
 i: integer;
 S:TstringList;
begin
 s := TStringList.Create;
 for i:=1 to StringGrid1.Cols[0].Count-1 do
  begin
   s.Add( StringGrid1.Cols[0][i] + '=' + StringGrid1.Cols[1][i])
  end;
 s.SaveToFile(DictionaryFile);
 s.Destroy;
end;

procedure TDictionaryForm.Edit1Change(Sender: TObject);
var
 Count: integer;
 Flag: boolean;
begin
 if ( Edit1.Text = '' ) or ( Edit2.Text = '' ) then
  begin
   Button6.Enabled := false;
   Button1.Enabled := false;
  end;

 if Edit1.Text <> '' then
 begin
  Button6.Enabled := true;
  Button1.Enabled := true;

 try
  flag := false;
  for Count := DIndex[Ord(Edit1.Text[1])]._From to DIndex[Ord(Edit1.Text[1])]._To do
   if MatchesMask( AnsiUpperCase(Diction.Text[Count]),AnsiUpperCase( Edit1.Text + '*')) then
    begin
      StringGrid1.Row := Count;
      if Edit1.Text = StringGrid1.Cols[0][Count] then flag := true;
      break;
    end;
   if not(flag) then Edit2.Text := Edit1.Text;
 except
 end;
 end
 else
  Edit2.Text := Edit1.Text;
end;

procedure TDictionaryForm.StringGrid1DblClick(Sender: TObject);
begin
 Edit1.Text := StringGrid1.Cells[0,SelCount];
 Edit2.Text := StringGrid1.Cells[1,SelCount];
end;

procedure TDictionaryForm.Edit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_RETURN then StringGrid1DblClick(Sender);
 if Key = VK_DOWN then StringGrid1.SetFocus;
end;

procedure TDictionaryForm.Button6Click(Sender: TObject);
begin
 MainForm.Speech1.Speak(Edit2.Text);
end;

procedure TDictionaryForm.Button5Click(Sender: TObject);
begin
 MainForm.OpenDialog1.InitialDir := ExtractFileDir( DictionaryFile );
 if MainForm.OpenDialog1.Execute then
  begin
    DictionaryFile := MainForm.OpenDialog1.FileName;
    SetMConf('Dictionary', DictionaryFile );
    FormActivate(Sender);
  end;
end;

procedure TDictionaryForm.Button7Click(Sender: TObject);
var
 S1, S2 : TStringList;
begin
 try
 MainForm.OpenDialog1.InitialDir := ExtractFileDir( DictionaryFile );
 if MainForm.OpenDialog1.Execute then
  begin
    S1 := TStringList.Create;
    S2 := TStringList.Create;
    S1.LoadFromFile( MainForm.OpenDialog1.FileName );
    ChDir(StartDir);
    if FileExists(DictionaryFile) then  S2.LoadFromFile(DictionaryFile);
    S1.AddStrings( S2 );
    S1.SaveToFile( DictionaryFile );
    S1.Destroy;
    S2.Destroy;
    FormActivate(Sender);
  end;
  except
  end;
end;

procedure TDictionaryForm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_ESCAPE then Close;
end;

procedure TDictionaryForm.StringGrid1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_Delete then  Button4Click(Sender);
end;

procedure TDictionaryForm.StringGrid1KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = VK_Return then
  begin
   Edit1.Text := StringGrid1.Cells[0,SelCount];
   Edit2.Text := StringGrid1.Cells[1,SelCount];
   Edit1.SetFocus;
  end;
end;

procedure TDictionaryForm.AdjustCaptions;
begin
 Caption := GetLConf('DCCaption');
 Label2.Caption := GetLConf('DCDiction');
 Label3.Caption := GetLConf('DCText');
 Label4.Caption := GetLConf('DCReadAs');
 Button6.Caption := GetLConf('DCTest');
 Button1.Caption := GetLConf('DCAdd');
 Button4.Caption := GetLConf('DCDel');
 Button7.Caption := GetLConf('DCExport');
 Button3.Caption := GetLConf('DCSave');
 Button2.Caption := GetLConf('DCClose');
 Button5.Caption := GetLConf('DCChoise');
end;


end.
